#ifndef MEDIA_VORBISCOMMENTIDS_H
#define MEDIA_VORBISCOMMENTIDS_H

#include <c++utilities/application/global.h>

namespace Media {

/*!
 * \brief Encapsulates Vorbis comment IDs.
 */
namespace VorbisCommentIds {

inline LIB_EXPORT const char *trackNumber() {
    return "TRACKNUMBER";
}
inline LIB_EXPORT const char *diskNumber() {
    return "DISCNUMBER";
}
inline LIB_EXPORT const char *part() {
    return "PART";
}
inline LIB_EXPORT const char *partNumber() {
    return "PARTNUMBER";
}
inline LIB_EXPORT const char *title() {
    return "TITLE";
}
inline LIB_EXPORT const char *version() {
    return "VERSION";
}
inline LIB_EXPORT const char *artist() {
    return "ARTIST";
}
inline LIB_EXPORT const char *album() {
    return "ALBUM";
}
inline LIB_EXPORT const char *label() {
    return "LABEL";
}
inline LIB_EXPORT const char *labelNo() {
    return "LABELNO";
}
inline LIB_EXPORT const char *performer() {
    return "PERFORMER";
}
inline LIB_EXPORT const char *composer() {
    return "COMPOSER";
}
inline LIB_EXPORT const char *ensemble() {
    return "ENSEMBLE";
}
inline LIB_EXPORT const char *arranger() {
    return "ARRANGER";
}
inline LIB_EXPORT const char *lyricist() {
    return "LYRICIST";
}
inline LIB_EXPORT const char *author() {
    return "AUTHOR";
}
inline LIB_EXPORT const char *conductor() {
    return "CONDUCTOR";
}
inline LIB_EXPORT const char *encodedBy() {
    return "ENCODED-BY";
}
inline LIB_EXPORT const char *publisher() {
    return "PUBLISHER";
}
inline LIB_EXPORT const char *genre() {
    return "GENRE";
}
inline LIB_EXPORT const char *originalMediaType() {
    return "ORIGINAL_MEDIA_TYPE";
}
inline LIB_EXPORT const char *contentType() {
    return "CONTENT_TYPE";
}
inline LIB_EXPORT const char *subject() {
    return "SUBJECT";
}
inline LIB_EXPORT const char *description() {
    return "DESCRIPTION";
}
inline LIB_EXPORT const char *isrc() {
    return "ISRC";
}
inline LIB_EXPORT const char *eanupn() {
    return "EAN/UPN";
}
inline LIB_EXPORT const char *comment() {
    return "COMMENT";
}
inline LIB_EXPORT const char *encoderSettings() {
    return "ENCODING";
}
inline LIB_EXPORT const char *date() {
    return "DATE";
}
inline LIB_EXPORT const char *location() {
    return "LOCATION";
}
inline LIB_EXPORT const char *license() {
    return "LICENSE";
}
inline LIB_EXPORT const char *copyright() {
    return "COPYRIGHT";
}
inline LIB_EXPORT const char *opus() {
    return "OPUS";
}
inline LIB_EXPORT const char *sourceMedia() {
    return "SOURCEMEDIA";
}
inline LIB_EXPORT const char *cover() {
    return "METADATA_BLOCK_PICTURE";
}

}

}

#endif // MEDIA_VORBISCOMMENTIDS_H
